unit IShlFold;

interface

uses Windows,ActiveX,CommCtrl,ShellAPI,RegStr,Messages,ComObj,
     ComServ,ShlObj,Classes,IShlView,Dialogs;

const
     CLSID_CustomShellFolder:TGUID='{BF029401-68CC-11D2-9B02-0000E844A5C5}';

type
    TCustomShellFolder=class(TComObject,IShellFolder,IPersistFolder)
   protected
      function IPersistFolder.Initialize=PersistInitialize;
   public
      {IShellFolder}
      function ParseDisplayName(hwndOwner:HWND;pbcReserved:Pointer; lpszDisplayName:POLESTR;
                                out pchEaten:ULONG;out ppidl:PItemIDList;var dwAttributes:ULONG):HResult;stdcall;
      function EnumObjects(hwndOwner:HWND;grfFlags:DWORD;out EnumIDList:IEnumIDList):HResult;stdcall;
      function BindToObject(pidl:PItemIDList;pbcReserved:Pointer;const riid:TIID;out ppvOut):HResult;stdcall;
      function BindToStorage(pidl:PItemIDList;pbcReserved:Pointer;const riid:TIID;out ppvObj):HResult;stdcall;
      function CompareIDs(lParam:LPARAM;pidl1,pidl2:PItemIDList):HResult;stdcall;
      function CreateViewObject(hwndOwner:HWND;const riid:TIID;out ppvOut{:Pointer}):HResult;stdcall;
      function GetAttributesOf(cidl:UINT;var apidl:PItemIDList;var rgfInOut:UINT):HResult;stdcall;
      function GetUIObjectOf(hwndOwner:HWND;cidl:UINT;var apidl:PItemIDList;const riid:TIID;prgfInOut:Pointer;out ppvOut):HResult;stdcall;
      function GetDisplayNameOf(pidl:PItemIDList;uFlags:DWORD;var lpName:TStrRet):HResult;stdcall;
      function SetNameOf(hwndOwner:HWND;pidl:PItemIDList;lpszName:POLEStr;uFlags:DWORD;var ppidlOut:PItemIDList):HResult;stdcall;
      {Persist}
      function GetClassID(out classID:TCLSID):HResult;stdcall;
      function PersistInitialize(pidl:PItemIDList):HResult;virtual;stdcall;
   end;

implementation
uses Registry;

type
    TShellFolderObjectFactory=class(TComObjectFactory)
   public
      procedure UpdateRegistry(Register:Boolean);override;
   end;
function TCustomShellFolder.ParseDisplayName(hwndOwner:HWND;pbcReserved:Pointer;lpszDisplayName:POLESTR;out pchEaten:ULONG;out ppidl:PItemIDList;var dwAttributes:ULONG):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.EnumObjects(hwndOwner:HWND;grfFlags:DWORD;out EnumIDList:IEnumIDList):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.BindToObject(pidl:PItemIDList;pbcReserved:Pointer;const riid:TIID;out ppvOut):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.BindToStorage(pidl:PItemIDList;pbcReserved:Pointer;const riid:TIID;out ppvObj):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.CompareIDs(lParam:LPARAM;pidl1,pidl2:PItemIDList):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.CreateViewObject(hwndOwner:HWND;const riid:TIID;out ppvOut{:Pointer}):HResult;
var SV:IShellView;
begin
     try
        Pointer(ppvOut):=nil;
        if IsEqualGUID(riid,IShellView)
                                        then begin
                                                  try
                                                     SV:=CreateComObject(CLSID_CustomShellView) as IShellView;
                                                  except
                                                        CoInitialize(nil);
                                                        SV:=CreateComObject(CLSID_CustomShellView) as IShellView;
                                                  end;
                                                  if Assigned(SV)
                                                                 then begin
                                                                           SV._AddRef;
                                                                           Pointer(ppvOut):=Pointer(SV);
                                                                      end;
                                                  Result:=S_OK;
                                             end
           else Result:=E_NOINTERFACE;
     except
           on E:EOleSysError do Result:=E.ErrorCode;
           else Result:=E_UNEXPECTED;
     end;
end;

function TCustomShellFolder.GetAttributesOf(cidl:UINT;var apidl:PItemIDList;var rgfInOut:UINT):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.GetUIObjectOf(hwndOwner:HWND;cidl:UINT;var apidl:PItemIDList;const riid:TIID;prgfInOut:Pointer;out ppvOut):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.GetDisplayNameOf(pidl:PItemIDList;uFlags:DWORD;var lpName:TStrRet):HResult;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellFolder.SetNameOf(hwndOwner:HWND;pidl:PItemIDList;lpszName:POLEStr;uFlags:DWORD;var ppidlOut:PItemIDList):HResult;
begin
     Result:=E_NOTIMPL;
end;

{IPersistFolder}

function TCustomShellFolder.GetClassID(out classID:TCLSID):HResult;
begin
     classID:=CLSID_CustomShellFolder;
     Result:=NOERROR;
end;

function TCustomShellFolder.PersistInitialize(pidl:PItemIDList):HResult;
begin
     Result:=NOERROR;
end;
{---------------------------------------------}

procedure TShellFolderObjectFactory.UpdateRegistry(Register:boolean);
var Reg:TRegistry;
    B:array[0..3]of byte;
begin
     if Register
                then begin
                          inherited UpdateRegistry(Register);
                          Reg:=nil;
                          try
                             Reg:=TRegistry.Create;
                             Reg.RootKey:=HKEY_CLASSES_ROOT;
                             Reg.OpenKey('CLSID\'+GUIDToString(CLSID_CustomShellFolder)+'\InprocServer32',True);
                             Reg.WriteString('ThreadingModel','Apartment');
                             Reg.CloseKey;
                             Reg.OpenKey('CLSID\'+GUIDToString(CLSID_CustomShellFolder)+'\ShellFolder',True);
                             Reg.WriteString('','');
                             B[0]:=$40;
                             B[1]:=$01;
                             B[2]:=$00;
                             B[3]:=$20;
                             Reg.WriteBinaryData('Attributes',B,sizeof(B));
                             Reg.CloseKey;
                             Reg.RootKey:=HKEY_LOCAL_MACHINE;
                             Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Desktop\Namespace\'+GUIDToString(CLSID_CustomShellFolder),True);
                             Reg.WriteString('','Shell Test view object');
                             Reg.CloseKey;
                          finally
                                 Reg.Free;
                          end;
                     end
        else begin
                  Reg:=nil;
                  try
                     Reg:=TRegistry.Create;
                     Reg.Rootkey:=HKEY_LOCAL_MACHINE;
                     Reg.DeleteKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Desktop\Namespace\'+GUIDToString(CLSID_CustomShellFolder));
                     Reg.CloseKey;
                  finally
                         if Assigned(Reg)
                                         then Reg.Free;
                  end;
                  inherited UpdateRegistry(Register);
             end;
end;

initialization
TShellFolderObjectFactory.Create(ComServer,TCustomShellFolder,CLSID_CustomShellFolder,'','Inprise fish viewer',ciSingleInstance);

end.
