unit IShlView;

interface

uses Windows,ActiveX,ShellAPI,ComObj,ComServ,ShlObj,CommCtrl,UTestF;

const
     CLSID_CustomShellView:TGUID='{BF029403-68CC-11D2-9B02-0000E844A5C5}';

type
    TCustomShellView=class(TComObject,IShellView)
   private
      FFolderSettings:TFolderSettings;
      FShellBrowser:IShellBrowser;
      FHWndParent:HWND;
      FForm:TForm1;
   public
      {IOleWindow Methods}
      function GetWindow(out wnd:HWnd):HResult;stdcall;
      function ContextSensitiveHelp(fEnterMode:BOOL):HResult;stdcall;
      {IShellView Methods}
      function TranslateAccelerator(var Msg:TMsg):HResult;stdcall;
      function EnableModeless(Enable:Boolean):HResult;stdcall;
      function UIActivate(State:UINT):HResult;stdcall;
      function Refresh:HResult;stdcall;
      function CreateViewWindow(PrevView:IShellView;var FolderSettings:TFolderSettings;ShellBrowser:IShellBrowser;var Rect:TRect;out Wnd:HWND):HResult;stdcall;
      function DestroyViewWindow:HResult;stdcall;
      function GetCurrentInfo(out FolderSettings:TFolderSettings):HResult;stdcall;
      function AddPropertySheetPages(Reseved:DWORD;var lpfnAddPage:TFNAddPropSheetPage;lParam:LPARAM):HResult;stdcall;
      function SaveViewState:HResult;stdcall;
      function SelectItem(pidl:PItemIDList;flags:UINT):HResult;stdcall;
      function GetItemObject(Item:UINT;const iid:TIID;var IPtr:Pointer):HResult;stdcall;
   end;

implementation
Uses Dialogs,SysUtils,Forms;

type
    TShellViewFactory=class(TComObjectFactory)
   public
      procedure UpdateRegistry(Register:Boolean);override;
   end;

function TCustomShellView.GetWindow(out wnd:HWND):HResult;stdcall;
begin
     if Assigned(FForm) then Wnd:=FForm.Handle
        else Wnd:=0;
     Result:=NOERROR;
end;

function TCustomShellView.ContextSensitiveHelp(fEnterMode:BOOL):HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellView.TranslateAccelerator(var Msg:TMsg):HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellView.EnableModeless(Enable:Boolean):HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellView.UIActivate(State:UINT):HResult;stdcall;
var S:string;
begin
     case TSVUIAEnums(State) of
          SVUIA_DEACTIVATE:S:='Deactivate view';
          SVUIA_ACTIVATE_NOFOCUS:S:='Activate view without focus';
          SVUIA_ACTIVATE_FOCUS:S:='Activate view with focus';
          SVUIA_INPLACEACTIVATE:S:='Activate view for inplace-activation within ActiveX control';
     end;
     FShellBrowser.SetStatusTextSB(StringToOleStr('IShellView.UIActivate:'+S));
     Result:=NOERROR;
end;

function TCustomShellView.Refresh:HResult;stdcall;
begin
     FShellBrowser.SetStatusTextSB(StringToOleStr('IShellView.Refresh'));
     Result:=E_NOTIMPL;
end;

function TCustomShellView.CreateViewWindow(PrevView:IShellView;var FolderSettings:TFolderSettings;ShellBrowser:IShellBrowser;var Rect:TRect;out Wnd:HWND):HResult;stdcall;
begin
     FFolderSettings:=FolderSettings;
     FShellBrowser:=ShellBrowser;
     if Assigned(FShellBrowser) then 
            FShellBrowser.GetWindow(FHWndParent)
     else FHWndParent:=0;
     if not Assigned(FForm) then FForm:=TForm1.Create(nil);
     Wnd:=FForm.Handle;
     if FHWndParent<>0 then 
     begin
         SetParent(Wnd,FHWndParent);
         with FForm do
         begin
           SetWindowPos(Handle,HWND_TOP,Rect.Left,Rect.Top,Rect.Right-Rect.Left,Rect.Bottom-Rect.Top,SWP_SHOWWINDOW);
           Show;
         end;
     end
     else begin
            FForm.BorderStyle:=bsDialog;
            FForm.ShowModal;
          end;
     if Wnd<>0 then Result:=NOERROR
     else Result:=E_UNEXPECTED;
end;

function TCustomShellView.DestroyViewWindow:HResult;stdcall;
begin
     if Assigned(FForm) then FForm.Free;
     FForm:=nil;
     Result:=NOERROR;
end;

function TCustomShellView.GetCurrentInfo(out FolderSettings:TFolderSettings):HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellView.AddPropertySheetPages(Reseved:DWORD;var lpfnAddPage:TFNAddPropSheetPage;lParam:LPARAM):HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellView.SaveViewState:HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

function TCustomShellView.SelectItem(pidl:PItemIDList;flags:UINT):HResult;stdcall;
begin
     Result:=NOERROR;
end;

function TCustomShellView.GetItemObject(Item:UINT;const iid:TIID;var IPtr:Pointer):HResult;stdcall;
begin
     Result:=E_NOTIMPL;
end;

{----------------------------------------}
procedure TShellViewFactory.UpdateRegistry(Register:Boolean);
begin
     if Register then 
     begin
       CreateRegKey('CLSID\'+GUIDToString(CLSID_CustomShellView)+'\InprocServer32','ThreadingModel','Apartment');
           inherited UpdateRegistry(Register);
     end
     else begin
            inherited UpdateRegistry(Register);
          end;
end;

initialization

TShellViewFactory.Create(ComServer,TCustomShellView,CLSID_CustomShellView,'','View fish',ciMultiInstance);

end.
